#!/bin/csh 

# Input commands into sed script
rm -f raytr_eff.dat

# back of Cerenkov
@ back=130

# radius
@ r_lo=115
@ r_hi=115
@ radius=$r_lo

while ( $radius <= $r_hi ) 
 # upper corner of upper mirror
 @ m1c1x_lo=120
 @ m1c1x_hi=120
 @ m1c1x=$m1c1x_lo

 while ( $m1c1x <= $m1c1x_hi ) 
  # lower corner where two mirrors come together
  # i.e. m1c2x = m2c2x +1cm clearance
  @ m1c2x_lo=82
  @ m1c2x_hi=110
  @ m1c2x=$m1c2x_lo

  while ( $m1c2x <= $m1c2x_hi ) 
   if ( $m1c2x <= $m1c1x ) then
    @ m2c2x=$m1c2x
    @ m2c2x+=1

    # lower corner of lower mirror
    @ m2c1x_lo=106
    @ m2c1x_hi=120
    @ m2c1x=$m2c1x_lo

    while ( $m2c1x <= $m2c1x_hi )
     if ( $m2c2x <= $m2c1x ) then

      # check back of Cerenkov
      @ back10=$back 
      @ back10-=10
      if ( $m1c1x <= $back10 && $m2c1x <= $back10 ) then

      @ back11=$back
      @ back11-=11
      if ( $m1c1x > $back11 || $m2c1x > $back11 ) then
#      echo $m1c1x $m1c2x $m2c1x $m2c2x

      #focus1
      @ f1y_lo=50
      @ f1y_hi=90
      @ f1y=$f1y_lo
      while ( $f1y <= $f1y_hi ) 

      if ( $f1y >= 65 ) then
      @ f1x_lo=65
      @ f1x_hi=91
      @ f1x=$f1x_lo
      while ( $f1x <= $f1x_hi ) 

      @ f1phi_lo=200
      @ f1phi_hi=241
      @ f1phi=$f1phi_lo
      while ( $f1phi <= $f1phi_hi ) 
#      echo f1 $f1x $f1y $f1phi

       #focus2
       @ f2y_lo=-80
       @ f2y_hi=-40
       @ f2y=$f2y_lo
       while ( $f2y <= $f2y_hi ) 

       if ( $f2y <= -55 ) then
       @ f2x_lo=49
       @ f2x_hi=95
       @ f2x=$f2x_lo
       while ( $f2x <= $f2x_hi ) 

       @ f2phi_lo=282
       @ f2phi_hi=324
       @ f2phi=$f2phi_lo
       while ( $f2phi <= $f2phi_hi ) 
#       echo f2 $f2x $f2y $f2phi

# Input commands into sed script
        rm -f sedscr0100
	echo s/RADIUS/$radius/g > sedscr0100
        echo s/M1C1X/$m1c1x/g >> sedscr0100
        echo s/M1C2X/$m1c2x/g >> sedscr0100
        echo s/M2C1X/$m2c1x/g >> sedscr0100
        echo s/M2C2X/$m2c2x/g >> sedscr0100
        echo s/F1X/$f1x/g >> sedscr0100
        echo s/F1Y/$f1y/g >> sedscr0100
        echo s/F1PHI/$f1phi/g >> sedscr0100
        echo s/F2X/$f2x/g >> sedscr0100
        echo s/F2Y/$f2y/g >> sedscr0100
        echo s/F2PHI/$f2phi/g >> sedscr0100

# Run raytr
        echo $m1c1x $m1c2x $m2c1x $m2c2x f1 $f1x $f1y $f1phi f2 $f2x $f2y $f2phi
        rm -f input0100.tmp
        sed -f sedscr0100 in_hunt_focus.inp > input0100.tmp

	rm -f out0100.dat
        ./raytr < input0100.tmp > out0100.dat

# Search output file for eff and spot sizs
#        rm -f tmp0100.dat
#        rm -f tmp10100.dat
#        awk ' /in:  429/ { print $10}' out0100.dat > tmp0100.dat
#        sed -f sedscr10100 tmp0100.dat > tmp10100.dat 
#	eff=`cat tmp10100.dat`
#
#        rm -f tmp0100.dat
#	rm -f tmp10100.dat
#        awk ' /in:  429/ { print $13}' out0100.dat > tmp0100.dat
#        sed -f sedscr10100 tmp0100.dat > tmp10100.dat 
#	spot1=`cat tmp10100.dat`
#
#        if [ "$spot1" != "nan" ] 
#	then
#
#	 rm -f tmp0100.dat
#	 rm -f tmp10100.dat
#         awk ' /in:  429/ { print $14}' out0100.dat > tmp0100.dat
#         sed -f sedscr10100 tmp0100.dat > tmp10100.dat 
#	 spot2=`cat tmp10100.dat`
#	 if [ "$spot2" != "nan" ]
#	 then
#	  echo $eff $spot1 $spot2 $radius $m1c1x $m1c2x $m2c1x $m2c2x $f1x $f1y $f1phi $f2x $f2y $f2phi 
#	 fi
#        fi

	set tst1=`cat tmp1.dat`
	if ( "$tst1" != "nan" ) then
	   @ rfy1=`cat tmp1.dat`
	else
	   goto cc2
	endif
	if ( $rfy1 < 65 ) then
	  goto aa
	endif

	set tst2=`cat tmp2.dat`
	if ( "$tst2" != "nan" ) then
	   @ rfy2=`cat tmp2.dat`
	else
	   goto cc
	endif
	if ( $rfy2 > -55 ) then
	  goto bb
	endif
cc:
       @ f2phi+=10
       end   # f2phi loop
bb:
       @ f2x+=5
       end   # f2x loop
       endif # if f2y<-55
      @ f2y+=5
       end   # f2y loop
cc2:
      @ f1phi+=10
      end    # f1phi loop
aa:
      @ f1x+=5
      end    # f1x loop
      endif  # if f1y>65
      @ f1y+=5 
      end    # f1y loop

      endif  # if back11
      endif  # if back10
     endif   # if m2c2x<m1c1x

     @ m2c1x+=2
    end      # m2c1x loop
   endif     # if m1c2x<m1c1x

   @ m1c2x+=1
  end        # m1c2x loop
  @ m1c1x+=2
 end         # m1c1x loop
 @ radius+=5
end          # radius loop

rm -f sedscr0100
